GNU bug report logs - #32227
[PATCH] gnu: rust: make rust 1.25.0 build reproducible

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix-patches; Reported by: Nikolai Merinov <nikolai.merinov@HIDDEN>; Keywords: patch; dated Fri, 20 Jul 2018 20:10:01 UTC; Maintainer for guix-patches is guix-patches@HIDDEN.

Message received at 32227 <at> debbugs.gnu.org:


Received: (at 32227) by debbugs.gnu.org; 23 Sep 2018 21:38:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Sep 23 17:38:38 2018
Received: from localhost ([127.0.0.1]:51174 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g4C5J-0000UT-Rz
	for submit <at> debbugs.gnu.org; Sun, 23 Sep 2018 17:38:38 -0400
Received: from mail-lj1-f175.google.com ([209.85.208.175]:40783)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1g4C5H-0000UF-Nw
 for 32227 <at> debbugs.gnu.org; Sun, 23 Sep 2018 17:38:32 -0400
Received: by mail-lj1-f175.google.com with SMTP id j19-v6so16489955ljc.7
 for <32227 <at> debbugs.gnu.org>; Sun, 23 Sep 2018 14:38:31 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=BvAKIN4+yQn1eBgt8i5ypNDzoRV1KQ/kvHyp+hWQtm8=;
 b=pf83Ix37LH6gOVfwJ+jl6d7V5bGZbPDXz092WfxnRQVjMnWWEFxArXLvTlpl15r8NS
 SMjwHyB6sOZKCXB5zUmUZB25ckA50mCVPATBs3tW3AirkdE3aIbvWi9wSLWCXFv+UStM
 eZYhxGNGzRLanZJ2/z+kskFvykQfrbV0vDkgS2aMdIujlcOvomRi29mV35qnw79nKzfl
 IbFKBtTKx9j1UvViiTUo48+KAzRuALO49inkqccpm4Jikjtpr2pJVMhegeFJWZcBvr1X
 QhGpMjw7LYa/+Fpqa6TLQ22crhfAoFJo+lmtyijBQMo6Kl5GVTE4DaBfHlN9HwhSzk1q
 5cQw==
X-Gm-Message-State: ABuFfogLhoBdUXwCZxaCIVxI4x62nK8QeyWjnIHP9IRegXQ5k+nX2Ida
 wGYIGurRnu2md8Xa0+W3Bg09CJyD
X-Google-Smtp-Source: ANB0VdYCxOeX7oD+/OFk99BEB9H099hRpcRdoKbVDPIqlHGyPCFtoIEzHZOM+xfpmijTiElqcgbOnA==
X-Received: by 2002:a2e:7809:: with SMTP id
 t9-v6mr5100559ljc.120.1537738705734; 
 Sun, 23 Sep 2018 14:38:25 -0700 (PDT)
Received: from libremnd ([2a02:2698:1822:a603:d01:a986:c036:3700])
 by smtp.gmail.com with ESMTPSA id 33-v6sm256721lfu.64.2018.09.23.14.38.24
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 23 Sep 2018 14:38:24 -0700 (PDT)
From: Nikolai Merinov <nikolai.merinov@HIDDEN>
To: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
Subject: Re: [bug#32227] [PATCH] gnu: rust: make rust 1.25.0 build reproducible
References: <87a7qlk6tx.fsf@HIDDEN>
 <handler.32227.B.153211738124061.ack <at> debbugs.gnu.org>
 <876019k698.fsf_-_@HIDDEN> <877eln61cv.fsf@HIDDEN>
 <87efermn81.fsf@HIDDEN>
Date: Mon, 24 Sep 2018 02:38:22 +0500
In-Reply-To: <87efermn81.fsf@HIDDEN> ("Ludovic
 \=\?utf-8\?Q\?Court\=C3\=A8s\=22'\?\=
 \=\?utf-8\?Q\?s\?\= message of "Tue, 21 Aug 2018 23:19:42 +0200")
Message-ID: <8736tzlws1.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 32227
Cc: 32227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

--=-=-=
Content-Type: text/plain

Hello Ludo,

Sorry for long answer. I have no chance to continue ivestigation last
month, but I'll want to provide my old finding:

1. Rust 1.25 build cargo binary (but not rustc itself) in
non-reproducible manner when compiled with llvm-6.0 and llvm-6.1. In
both cases we got non-reproducible code for next functions:
"<env_logger::Logger as log::Log>::log", "git2::panic::check",
"curl::easy::handler::ssl_ctx_cb".
2. Rust 1.26 with llvm-6.0 build is reproducible regardless of which
rustc 1.25 (with llvm-6.0 or llvm-3.9) was used to bootstrap it.
3. Rust 1.27.0 and Rust 1.27.2 again build rustc itself in reproducible
manner, while "cargo" binary differ build to build. I observed
non-reproducible code in "git2::panic::check" function and in
".gcc_except_table" section of resulting binary.

In attachements you can find patch to move rust-1.25 to llvm-3.9, and
patch to update Rust 1.27 to 1.27.2. 
--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0001-gnu-rust-make-rust-1.25.0-build-reproducible.patch
Content-Description: enable llvm-6.0 in rust 1.26 instead of 1.25

From: Nikolai Merinov <nikolai.merinov@HIDDEN>
To: guix-patches@HIDDEN
Subject: [PATCH] gnu: rust: make rust 1.25.0 build reproducible

* gnu/packages/rust.scm (rust-1.25): switch back to llvm@HIDDEN still builds with
llvm@HIDDEN is not reproducible. Remove all llvm@HIDDEN related twicks.
(rust-1.26): switch to llvm@HIDDEN still rust-1.26 can build reproducible
binaries with new llvm release. Enable llvm@HIDDEN related twicks.
---
 gnu/packages/rust.scm | 39 ++++++++++++++++++---------------------
 1 file changed, 18 insertions(+), 21 deletions(-)

diff --git a/gnu/packages/rust.scm b/gnu/packages/rust.scm
index 28bffb44b..1095070eb 100644
--- a/gnu/packages/rust.scm
+++ b/gnu/packages/rust.scm
@@ -545,10 +545,6 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                                     "0baxjr99311lvwdq0s38bipbnj72pn6fgbk6lcq7j555xq53mxpf")))
     (package
       (inherit base-rust)
-      (inputs
-       ;; Use LLVM 6.0
-       (alist-replace "llvm" (list llvm)
-                      (package-inputs base-rust)))
       (arguments
        (substitute-keyword-arguments (package-arguments base-rust)
          ((#:phases phases)
@@ -559,23 +555,6 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                    ;; This test wants to update the crate index.
                    (("fn no_index_update") "#[ignore]\nfn no_index_update"))
                  #t))
-             (add-after 'configure 'enable-codegen-tests
-               (lambda _
-                 (substitute* "config.toml"
-                   (("codegen-tests = false") ""))
-                 #t))
-             (replace 'patch-aarch64-test
-               (lambda _
-                 (substitute* "src/librustc_metadata/dynamic_lib.rs"
-                   ;; This test is known to fail on aarch64 and powerpc64le:
-                   ;; https://github.com/rust-lang/rust/issues/45410
-                   (("fn test_loading_cosine") "#[ignore]\nfn test_loading_cosine"))
-                 ;; This test fails on aarch64 with llvm@HIDDEN:
-                 ;; https://github.com/rust-lang/rust/issues/49807
-                 ;; other possible solution:
-                 ;; https://github.com/rust-lang/rust/pull/47688
-                 (delete-file "src/test/debuginfo/by-value-self-argument-in-trait-impl.rs")
-                 #t))
              (delete 'ignore-glibc-2.27-incompatible-test))))))))
 
 (define-public rust-1.26
@@ -585,6 +564,10 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                                     #:patches '("rust-coresimd-doctest.patch"))))
     (package
       (inherit base-rust)
+      (inputs
+       ;; Use LLVM 6.0
+       (alist-replace "llvm" (list llvm)
+                      (package-inputs base-rust)))
       (arguments
        (substitute-keyword-arguments (package-arguments base-rust)
          ((#:phases phases)
@@ -624,6 +607,20 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                  (substitute* "src/tools/cargo/tests/testsuite/generate_lockfile.rs"
                    ;; This test wants to update the crate index.
                    (("fn no_index_update") "#[ignore]\nfn no_index_update"))
+                 #t))
+             (add-after 'patch-aarch64-test 'patch-aarch64-llvm6-test
+               (lambda _
+                 ;; This test fails on aarch64 with llvm@HIDDEN:
+                 ;; https://github.com/rust-lang/rust/issues/49807
+                 ;; other possible solution:
+                 ;; https://github.com/rust-lang/rust/pull/47688
+                 (delete-file "src/test/debuginfo/by-value-self-argument-in-trait-impl.rs")
+                 #t))
+             (add-after 'configure 'enable-codegen-tests
+               (lambda* _
+                 (substitute* "config.toml"
+                   ;; codegen test should pass with LLVM 6
+                   (("codegen-tests = false") ""))
                  #t)))))))))
 
 (define-public rust
-- 
2.17.1






--=-=-=
Content-Type: text/x-patch
Content-Disposition: attachment;
 filename=0002-Update-rust-1.27-to-1.27.2.patch
Content-Description: Update rust 1.27 to 1.27.2

diff --git a/gnu/packages/rust.scm b/gnu/packages/rust.scm
index 0695f8c7d..4bc8d1d88 100644
--- a/gnu/packages/rust.scm
+++ b/gnu/packages/rust.scm
@@ -631,8 +631,8 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
 
 (define-public rust
   (let ((base-rust
-         (rust-bootstrapped-package rust-1.26 "1.27.0"
-                                    "089d7rhw55zpvnw71dj8vil6qrylvl4xjr4m8bywjj83d4zq1f9c"
+         (rust-bootstrapped-package rust-1.26 "1.27.2"
+                                    "0pg1s37bhx9zqbynxyydq5j6q7kij9vxkcv8maz0m25prm88r0cs"
                                     #:patches
                                     '("rust-coresimd-doctest.patch"
                                       "rust-bootstrap-stage0-test.patch"))))

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Regards,
Nikolai

ludo@HIDDEN (Ludovic Court=C3=A8s) writes:

> Hello Nikolai,
>
> Nikolai Merinov <nikolai.merinov@HIDDEN> skribis:
>
>> Please, do not merge. Change rejected. With this change 1.27.0 build
>> still not reproducible. I should try to figure out which llvm
>> compilation options make builds non-reproducible.
>
> Does the problem still apply to 1.27.0 as currently available in master?
>
> Thanks,
> Ludo=E2=80=99.

--=-=-=--




Information forwarded to guix-patches@HIDDEN:
bug#32227; Package guix-patches. Full text available.

Message received at 32227 <at> debbugs.gnu.org:


Received: (at 32227) by debbugs.gnu.org; 21 Aug 2018 21:19:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Aug 21 17:19:51 2018
Received: from localhost ([127.0.0.1]:57081 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fsE47-0003TG-1z
	for submit <at> debbugs.gnu.org; Tue, 21 Aug 2018 17:19:51 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56786)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1fsE45-0003T4-HX
 for 32227 <at> debbugs.gnu.org; Tue, 21 Aug 2018 17:19:49 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1fsE3z-0006pw-Ml
 for 32227 <at> debbugs.gnu.org; Tue, 21 Aug 2018 17:19:44 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:44358)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1fsE3z-0006pk-I3; Tue, 21 Aug 2018 17:19:43 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=54962 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1fsE3z-0001TB-A7; Tue, 21 Aug 2018 17:19:43 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Nikolai Merinov <nikolai.merinov@HIDDEN>
Subject: Re: [bug#32227] [PATCH] gnu: rust: make rust 1.25.0 build reproducible
In-Reply-To: <877eln61cv.fsf@HIDDEN> (Nikolai Merinov's message of
 "Sun, 22 Jul 2018 14:55:44 +0500")
References: <87a7qlk6tx.fsf@HIDDEN>
 <handler.32227.B.153211738124061.ack <at> debbugs.gnu.org>
 <876019k698.fsf_-_@HIDDEN> <877eln61cv.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
Date: Tue, 21 Aug 2018 23:19:42 +0200
Message-ID: <87efermn81.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 32227
Cc: 32227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

Hello Nikolai,

Nikolai Merinov <nikolai.merinov@HIDDEN> skribis:

> Please, do not merge. Change rejected. With this change 1.27.0 build
> still not reproducible. I should try to figure out which llvm
> compilation options make builds non-reproducible.

Does the problem still apply to 1.27.0 as currently available in master?

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#32227; Package guix-patches. Full text available.

Message received at 32227 <at> debbugs.gnu.org:


Received: (at 32227) by debbugs.gnu.org; 21 Aug 2018 21:19:44 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Aug 21 17:19:44 2018
Received: from localhost ([127.0.0.1]:57078 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fsE3z-0003Sw-QS
	for submit <at> debbugs.gnu.org; Tue, 21 Aug 2018 17:19:43 -0400
Received: from eggs.gnu.org ([208.118.235.92]:56755)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1fsE3y-0003Sk-Eh
 for 32227 <at> debbugs.gnu.org; Tue, 21 Aug 2018 17:19:42 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <ludo@HIDDEN>) id 1fsE3s-0006la-MO
 for 32227 <at> debbugs.gnu.org; Tue, 21 Aug 2018 17:19:37 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-1.9 required=5.0 tests=BAYES_00 autolearn=disabled
 version=3.3.2
Received: from fencepost.gnu.org ([2001:4830:134:3::e]:44357)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1fsE3s-0006lQ-IP; Tue, 21 Aug 2018 17:19:36 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=54960 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1fsE3s-0001T6-97; Tue, 21 Aug 2018 17:19:36 -0400
From: ludo@HIDDEN (Ludovic =?utf-8?Q?Court=C3=A8s?=)
To: Nikolai Merinov <nikolai.merinov@HIDDEN>
Subject: Re: [bug#32227] [PATCH] gnu: rust: make rust 1.25.0 build reproducible
References: <87a7qlk6tx.fsf@HIDDEN>
 <handler.32227.B.153211738124061.ack <at> debbugs.gnu.org>
 <876019k698.fsf_-_@HIDDEN> <877eln61cv.fsf@HIDDEN>
Date: Tue, 21 Aug 2018 23:19:34 +0200
In-Reply-To: <877eln61cv.fsf@HIDDEN> (Nikolai Merinov's message of
 "Sun, 22 Jul 2018 14:55:44 +0500")
Message-ID: <87ftz7mn89.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 2001:4830:134:3::e
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: 32227
Cc: 32227 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -6.0 (------)

Hello Nikolai,

Nikolai Merinov <nikolai.merinov@HIDDEN> skribis:

> Please, do not merge. Change rejected. With this change 1.27.0 build
> still not reproducible. I should try to figure out which llvm
> compilation options make builds non-reproducible.

Does the problem still applies to 1.27.0 as currently available in
master?

Thanks,
Ludo=E2=80=99.




Information forwarded to guix-patches@HIDDEN:
bug#32227; Package guix-patches. Full text available.

Message received at 32227 <at> debbugs.gnu.org:


Received: (at 32227) by debbugs.gnu.org; 22 Jul 2018 09:55:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Jul 22 05:55:55 2018
Received: from localhost ([127.0.0.1]:51555 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fhB5n-0006k5-4D
	for submit <at> debbugs.gnu.org; Sun, 22 Jul 2018 05:55:55 -0400
Received: from mail-lf1-f65.google.com ([209.85.167.65]:35299)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1fhB5k-0006jp-Rt
 for 32227 <at> debbugs.gnu.org; Sun, 22 Jul 2018 05:55:53 -0400
Received: by mail-lf1-f65.google.com with SMTP id f18-v6so4458676lfc.2
 for <32227 <at> debbugs.gnu.org>; Sun, 22 Jul 2018 02:55:52 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:in-reply-to:references
 :user-agent:date:message-id:mime-version;
 bh=KAPBDXIOqi8rWeVdrcZcuN3RhCHU4ZNkHTw1Rvzwfwg=;
 b=s1UF/LocLgZFBQvn9UipLEsshi97CI/sb0VZ44Q+ZM7LivT1H5m6DO56Ij7JHYSb81
 aYDF31bI9RF8fxXF5bnUqHCBwmhpG2VbJptTU4DwGG0fQ7k8in05R1jGgayz/qj9I44z
 wDcpzfWlSQzwe3xeu65NoolxHMDkLNsPUQYclqLAJE+GCCBqDixsxoTHeHkSTU1Oqg1X
 hteyz1S/JEAZMxBiyEvpdEOQIL2WRzSlYs8xhhbjtgXdTlkUZWfLeNq/Hm1GmbAMc2n9
 SbdJ9TvFtPJZRbx61VHMWZXGYCcj5CbOYQBQ1zO7y6vagdRsmZ40u6wTdG4comYKRtzG
 47Vg==
X-Gm-Message-State: AOUpUlFvHsczyIUY4222e/0GxDfO7LNHHUaTx31sEn5ovYrbTXPlDsk4
 WXnSmh8NYyw0P8n3e6uoTGaJLYy3
X-Google-Smtp-Source: AAOMgpcc2OWcd0EtxVQkcNlYsUIIEmordC7o9pwK9TvjH7eaopaQoE9p9iOup3I4pSIE66rkQfwDJg==
X-Received: by 2002:a19:f50d:: with SMTP id
 j13-v6mr4878960lfb.127.1532253346586; 
 Sun, 22 Jul 2018 02:55:46 -0700 (PDT)
Received: from libremnd (97.9-157-90.telenet.ru. [90.157.9.97])
 by smtp.gmail.com with ESMTPSA id v136-v6sm968690lfa.10.2018.07.22.02.55.45
 for <32227 <at> debbugs.gnu.org>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Sun, 22 Jul 2018 02:55:45 -0700 (PDT)
From: Nikolai Merinov <nikolai.merinov@HIDDEN>
To: 32227 <at> debbugs.gnu.org
Subject: Re: [PATCH] gnu: rust: make rust 1.25.0 build reproducible
In-Reply-To: <876019k698.fsf_-_@HIDDEN> (Nikolai Merinov's message of
 "Sat, 21 Jul 2018 01:21:39 +0500")
References: <87a7qlk6tx.fsf@HIDDEN>
 <handler.32227.B.153211738124061.ack <at> debbugs.gnu.org>
 <876019k698.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
Date: Sun, 22 Jul 2018 14:55:44 +0500
Message-ID: <877eln61cv.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 32227
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Hi, 

Please, do not merge. Change rejected. With this change 1.27.0 build
still not reproducible. I should try to figure out which llvm
compilation options make builds non-reproducible.

Regards,
Nikolai

Nikolai Merinov <nikolai.merinov@HIDDEN> writes:

> Hi,
>
> I tried to configure how rust use llvm, but I did not succeed in
> it. Looks like llvm@HIDDEN usage was fixed fully only in rust 1.26.
>
> I already checked once that 1.25 and 1.26 rust releases is reproducible
> in my environment with llvm@HIDDEN and llvm@HIDDEN respectively. When I posted
> this patch I restarted my builds with "--rounds=2".
>
> Regards,
> Nikolai




Information forwarded to guix-patches@HIDDEN:
bug#32227; Package guix-patches. Full text available.

Message received at 32227 <at> debbugs.gnu.org:


Received: (at 32227) by debbugs.gnu.org; 20 Jul 2018 20:21:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 20 16:21:50 2018
Received: from localhost ([127.0.0.1]:50003 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fgbuP-0006a2-Sl
	for submit <at> debbugs.gnu.org; Fri, 20 Jul 2018 16:21:50 -0400
Received: from mail-lf1-f65.google.com ([209.85.167.65]:38609)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1fgbuO-0006Zl-5R
 for 32227 <at> debbugs.gnu.org; Fri, 20 Jul 2018 16:21:48 -0400
Received: by mail-lf1-f65.google.com with SMTP id a4-v6so2603015lff.5
 for <32227 <at> debbugs.gnu.org>; Fri, 20 Jul 2018 13:21:48 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=dYkivN8vnT2qWRMh6C5wdkcucCHHzQOS9tzCet2UGbM=;
 b=YRLTDR4PqSb04R19p6rvK12MySVLVFWzcSaEduCAqC3YgSRM1iLBwc2c3rXojLeRhZ
 jxZzXGylXnHboiNvPklz5l6h9wW91ZKG36LIQzRFaMMSt+Yp9mETi/39BBXhXoKrRvNI
 jrBcqI6TjBFbjAMEWTh8NmarfyLSAYXSsDC5wRC2KWpP5aepGqnWTwyTElhooCZ2srrN
 PKkazOgBIy7UKYvbLvRB7EUnIIcuRDq+ke8wUpRhKRuK+sXvB4d7q3RFVmUM5V9AE0FD
 PJnMMERelIaVARi00uBvc6oj5QOrhr+p5hbMYQmSyKlR2tm2QsRAmUXdrfE7lz5GSzDa
 L88w==
X-Gm-Message-State: AOUpUlEMPPztR05L2zyzO+194lP5RQPw9BTag9F1AK4/0AZkWvxY48GM
 mqF2cl6THcZk+jTszggOC1AeLKAA
X-Google-Smtp-Source: AAOMgpeHj2kL4/uG7DJE2XgWSsMtrEOy+ZwIcXzK9zvQWy6ZT3caEKdg5UFDXSKEOL17x1n4nLVqFA==
X-Received: by 2002:a19:e546:: with SMTP id
 c67-v6mr2148777lfh.135.1532118102026; 
 Fri, 20 Jul 2018 13:21:42 -0700 (PDT)
Received: from libremnd (97.9-157-90.telenet.ru. [90.157.9.97])
 by smtp.gmail.com with ESMTPSA id h9-v6sm425962lfc.47.2018.07.20.13.21.40
 for <32227 <at> debbugs.gnu.org>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 20 Jul 2018 13:21:41 -0700 (PDT)
From: Nikolai Merinov <nikolai.merinov@HIDDEN>
To: 32227 <at> debbugs.gnu.org
Subject: Re: [PATCH] gnu: rust: make rust 1.25.0 build reproducible
References: <87a7qlk6tx.fsf@HIDDEN>
 <handler.32227.B.153211738124061.ack <at> debbugs.gnu.org>
Date: Sat, 21 Jul 2018 01:21:39 +0500
In-Reply-To: <handler.32227.B.153211738124061.ack <at> debbugs.gnu.org> (GNU bug
 Tracking System's message of "Fri, 20 Jul 2018 20:10:02 +0000")
Message-ID: <876019k698.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 32227
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Hi,

I tried to configure how rust use llvm, but I did not succeed in
it. Looks like llvm@HIDDEN usage was fixed fully only in rust 1.26.

I already checked once that 1.25 and 1.26 rust releases is reproducible
in my environment with llvm@HIDDEN and llvm@HIDDEN respectively. When I posted
this patch I restarted my builds with "--rounds=2".

Regards,
Nikolai




Information forwarded to guix-patches@HIDDEN:
bug#32227; Package guix-patches. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Jul 2018 20:09:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 20 16:09:40 2018
Received: from localhost ([127.0.0.1]:49984 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1fgbib-0006Fy-FG
	for submit <at> debbugs.gnu.org; Fri, 20 Jul 2018 16:09:40 -0400
Received: from eggs.gnu.org ([208.118.235.92]:33164)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1fgbiZ-0006Fl-Gi
 for submit <at> debbugs.gnu.org; Fri, 20 Jul 2018 16:09:36 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1fgbiT-00026y-4x
 for submit <at> debbugs.gnu.org; Fri, 20 Jul 2018 16:09:30 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: ***
X-Spam-Status: No, score=3.4 required=5.0 tests=BAYES_20,DATE_IN_PAST_96_XX,
 FREEMAIL_FROM autolearn=disabled version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:59126)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <nikolay.d.merinov@HIDDEN>)
 id 1fgbiT-00026u-1G
 for submit <at> debbugs.gnu.org; Fri, 20 Jul 2018 16:09:29 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:52358)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1fgbiR-00067U-P5
 for guix-patches@HIDDEN; Fri, 20 Jul 2018 16:09:28 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <nikolay.d.merinov@HIDDEN>) id 1fgbiM-000231-T3
 for guix-patches@HIDDEN; Fri, 20 Jul 2018 16:09:27 -0400
Received: from mail-lf1-f45.google.com ([209.85.167.45]:35241)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <nikolay.d.merinov@HIDDEN>)
 id 1fgbiM-00022U-Kv
 for guix-patches@HIDDEN; Fri, 20 Jul 2018 16:09:22 -0400
Received: by mail-lf1-f45.google.com with SMTP id f18-v6so2583338lfc.2
 for <guix-patches@HIDDEN>; Fri, 20 Jul 2018 13:09:21 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:subject:date:message-id:mime-version;
 bh=Wdbvya+eaWR028tV4xXgYDzaYfhQdSZfcBnnTbMNVZA=;
 b=BUf3f9KFrmYGbNYm5tBG91KibPNSW+pmK+gLBcojdFoGdkcadSHHgFJSZHXXFMjWSw
 M7xf23b3gVQuYlrbCNGXIHVO9+OUgQI1z8j/N+0QjeoxHtrmFtJ4Za8Wy8MvvfOo5LhM
 owklun85QO41n4L23W4vasGmR5ndSM82Eq4w/3+Rupjw/reUFuTEXqM5bc2jHxDJkTpt
 mWlGoxm7KVIIhmt0U8CFBpnY2u4An/qHNPeFdVKO22P5GEry5KPonnFTuTe8ZDdABg43
 msxKaP7Nk4MiHtlKmBIARExqwaSrFbfDnlqGoMYQUT9rzjlr4HWrXOeoZteg5arNb/em
 yR5A==
X-Gm-Message-State: AOUpUlGVGkrZIkqpdvLZlKrt5huds39nsnLNpn5Oxd9kJzWhgxEJTYdo
 B3xZzejp5Efx+U8MkbOaBAddzK1w
X-Google-Smtp-Source: AAOMgpfCF///0e48rCg5ApbF2QWTRgB1ussjAVB0VGOOWtAsD00zdNjw/cUHBUCyvxMkOv5Om4IY/A==
X-Received: by 2002:a19:c403:: with SMTP id u3-v6mr2122850lff.87.1532117359510; 
 Fri, 20 Jul 2018 13:09:19 -0700 (PDT)
Received: from libremnd (97.9-157-90.telenet.ru. [90.157.9.97])
 by smtp.gmail.com with ESMTPSA id t24-v6sm499132ljb.89.2018.07.20.13.09.17
 for <guix-patches@HIDDEN>
 (version=TLS1_2 cipher=ECDHE-RSA-CHACHA20-POLY1305 bits=256/256);
 Fri, 20 Jul 2018 13:09:18 -0700 (PDT)
From: Nikolai Merinov <nikolai.merinov@HIDDEN>
To: guix-patches@HIDDEN
Subject: [PATCH] gnu: rust: make rust 1.25.0 build reproducible
Date: Sat, 14 Jul 2018 01:15:11 +0500
Message-ID: <87a7qlk6tx.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -1.5 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.5 (--)

* gnu/packages/rust.scm (rust-1.25): switch back to llvm@HIDDEN still builds with
llvm@HIDDEN is not reproducible. Remove all llvm@HIDDEN related twicks.
(rust-1.26): switch to llvm@HIDDEN still rust-1.26 can build reproducible
binaries with new llvm release. Enable llvm@HIDDEN related twicks.
---
 gnu/packages/rust.scm | 39 ++++++++++++++++++---------------------
 1 file changed, 18 insertions(+), 21 deletions(-)

diff --git a/gnu/packages/rust.scm b/gnu/packages/rust.scm
index 28bffb44b..1095070eb 100644
--- a/gnu/packages/rust.scm
+++ b/gnu/packages/rust.scm
@@ -545,10 +545,6 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                                     "0baxjr99311lvwdq0s38bipbnj72pn6fgbk6lcq7j555xq53mxpf")))
     (package
       (inherit base-rust)
-      (inputs
-       ;; Use LLVM 6.0
-       (alist-replace "llvm" (list llvm)
-                      (package-inputs base-rust)))
       (arguments
        (substitute-keyword-arguments (package-arguments base-rust)
          ((#:phases phases)
@@ -559,23 +555,6 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                    ;; This test wants to update the crate index.
                    (("fn no_index_update") "#[ignore]\nfn no_index_update"))
                  #t))
-             (add-after 'configure 'enable-codegen-tests
-               (lambda _
-                 (substitute* "config.toml"
-                   (("codegen-tests = false") ""))
-                 #t))
-             (replace 'patch-aarch64-test
-               (lambda _
-                 (substitute* "src/librustc_metadata/dynamic_lib.rs"
-                   ;; This test is known to fail on aarch64 and powerpc64le:
-                   ;; https://github.com/rust-lang/rust/issues/45410
-                   (("fn test_loading_cosine") "#[ignore]\nfn test_loading_cosine"))
-                 ;; This test fails on aarch64 with llvm@HIDDEN:
-                 ;; https://github.com/rust-lang/rust/issues/49807
-                 ;; other possible solution:
-                 ;; https://github.com/rust-lang/rust/pull/47688
-                 (delete-file "src/test/debuginfo/by-value-self-argument-in-trait-impl.rs")
-                 #t))
              (delete 'ignore-glibc-2.27-incompatible-test))))))))
 
 (define-public rust-1.26
@@ -585,6 +564,10 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                                     #:patches '("rust-coresimd-doctest.patch"))))
     (package
       (inherit base-rust)
+      (inputs
+       ;; Use LLVM 6.0
+       (alist-replace "llvm" (list llvm)
+                      (package-inputs base-rust)))
       (arguments
        (substitute-keyword-arguments (package-arguments base-rust)
          ((#:phases phases)
@@ -624,6 +607,20 @@ jemalloc = \"" jemalloc "/lib/libjemalloc_pic.a" "\"
                  (substitute* "src/tools/cargo/tests/testsuite/generate_lockfile.rs"
                    ;; This test wants to update the crate index.
                    (("fn no_index_update") "#[ignore]\nfn no_index_update"))
+                 #t))
+             (add-after 'patch-aarch64-test 'patch-aarch64-llvm6-test
+               (lambda _
+                 ;; This test fails on aarch64 with llvm@HIDDEN:
+                 ;; https://github.com/rust-lang/rust/issues/49807
+                 ;; other possible solution:
+                 ;; https://github.com/rust-lang/rust/pull/47688
+                 (delete-file "src/test/debuginfo/by-value-self-argument-in-trait-impl.rs")
+                 #t))
+             (add-after 'configure 'enable-codegen-tests
+               (lambda* _
+                 (substitute* "config.toml"
+                   ;; codegen test should pass with LLVM 6
+                   (("codegen-tests = false") ""))
                  #t)))))))))
 
 (define-public rust
-- 
2.17.1





Acknowledgement sent to Nikolai Merinov <nikolai.merinov@HIDDEN>:
New bug report received and forwarded. Copy sent to guix-patches@HIDDEN. Full text available.
Report forwarded to guix-patches@HIDDEN:
bug#32227; Package guix-patches. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 23 Sep 2018 21:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.